SystemOrganization addCategory: #'OCMS-Database'!

Object subclass: #OCMSDB
	instanceVariableNames: 'session'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OCMS-Database'!

!OCMSDB class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 00:41'!
addIndexAt: aTableName withIndex: anIndex
	"I create an index of a DBObject in OCMSDB if they do not exist"

	((self session root at: aTableName) hasIndexNamed: anIndex attribute)
		ifFalse:[(self session root at: aTableName) addIndex: anIndex].
! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'oda 6/30/2013 23:52'!
clearAndRestart
	OCMSDB stop.
	OCMSDB deleteRepository.
	OCMSDB createRepository.
	OCMSDB start.
	OCMSDB updateDBObjects.
	OCMSDB updateIndexes.
	! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'has 6/2/2013 17:58'!
commit: anDBOperation
	self default session commit: anDBOperation.
	self session refresh.! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'oda 6/30/2013 23:51'!
createRepository
	MagmaRepositoryController
		create: 'ocmsdb'
		root: Dictionary new.! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'has 5/25/2013 19:15'!
default
	^ Default ifNil: [Default := self new connect; yourself].! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'oda 6/30/2013 23:50'!
deleteRepository
	MagmaRepositoryController
		delete: 'ocmsdb'.! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'has 7/2/2013 22:29'!
populate
	| um cm gm  cwm
	admin admin2 user user2 user3
	course group group2 cw tag1 tag2 ocTag ocAut stringAuthor |
	
	um := UserManager new.
	cm := CourseManager new.
	gm := GroupManager new.
	cwm := CoursewareManager new.

	admin:=User new.
	admin login: 'admin'.
	admin username: 'Admin'.
	admin email: 'admin@test.com'.
	admin password: '123' hash.
	admin isEnabled: true.
	admin isAdmin: true.
	(Users loginExists: admin login) ifFalse: [
		um includeUser: admin.
	].
	
	admin2:=User new.
	admin2 login: 'admin2'.
	admin2 username: 'Admin2'.
	admin2 email: 'admin2@test.com'.
	admin2 password: '123' hash.
	admin2 isEnabled: true.
	admin2 isAdmin: true.
	(Users loginExists: admin2 login) ifFalse: [
		um includeUser: admin2.
	].

	user:=User new.
	user login: 'higor'.
	user username: 'Higor Amario de Souza'.
	user email: 'hamario@ime.usp.br'.
	user password: '123' hash.
	user isEnabled: true.
	user isAdmin: false.
	(Users loginExists: user login) ifFalse: [
		um includeUser: user.
	].

	user2:=User new.
	user2 login: 'monna'.
	user2 username: 'Monna Cleide Santos'.
	user2 email: 'monnacs@gmail.com'.
	user2 password: '123' hash.
	user2 isEnabled: true.
	user2 isAdmin: false.
	(Users loginExists: user2 login) ifFalse: [
		um includeUser: user2.
	].

	user3:=User new.
	user3 login: 'ricardo'.
	user3 username: 'Ricardo Oda'.
	user3 email: 'odaric@ime.usp.br'.
	user3 password: '123' hash.
	user3 isEnabled: true.
	user3 isAdmin: false.
	(Users loginExists: user3 login) ifFalse: [
		um includeUser: user3.
	].

	course := Course new.
	course description: 'Programao Orientada a Objetos'.
	(Courses includes: course) ifFalse: [
		cm includeCourse: course.
	].

	group := Group new.
	group description: 'POO2013-Ps'.
	group password: '123' hash.
	group isOpen: false.
	group isEnabled: true.
	(Groups includes: group at: course) ifFalse: [
		user includeOrUpdateGroup: group withRole: UserType student.
		user2 includeOrUpdateGroup: group withRole: UserType student.
		user3 includeOrUpdateGroup: group withRole: UserType student.
		gm includeGroup: group atCourse: course byUser: admin.
		um update: user.
		um update: user2.
		um update: user3.
	].   

	group2 := Group new.
	group2 description: 'POO2013-Open'.
	group2 isEnabled: true.
	(Groups includes: group2 at: course) ifFalse: [
		gm includeGroup: group2 atCourse: course byUser: admin2.
	].   
	
	cw := Courseware new.
	cw title: 'Example'.
	cw owner: user3.
	cw course add: course.
	cw summary: 'An example of courseware.'.  
	cw description: 'This is an example of courseware. You can add your own courseware by following the Add link. If you want. it''s possible to include downloadable content. After creating, it will be available for all groups within the course in which this material was created'.
	cw license: LicenseType publicDomain.
	cw isEnabled: true.
	stringAuthor:='Author example'.
	ocAut:= OrderedCollection new.
	ocAut add: stringAuthor.
	cw author: ocAut.
	tag1:=Tag new.
	tag1 label: 'Tag example'.
	tag2:=Tag new.
	tag2 label: 'Science'.
	ocTag:= OrderedCollection new.
	ocTag add:tag1.
	ocTag add:tag2.
	cw tag: ocTag.
	(Coursewares searchByTitle: cw title) isEmpty ifTrue: [
		cwm includeCourseware: cw.  
	]   
	! !

!OCMSDB class methodsFor: 'dependents access' stamp: 'oda 6/29/2013 13:45'!
release
	Default ifNotNil: [
		Default session disconnectAndClose.
		Default := nil.
		]! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'has 5/25/2013 19:22'!
root
	^ self session root! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'has 5/25/2013 19:20'!
session
	^ self default session! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'oda 6/30/2013 23:51'!
start
	MagmaServerConsole new
		open: 'ocmsdb' ;
		processOn: 51001.
	! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'oda 6/30/2013 23:50'!
stop
	OCMSDB release.
	MagmaSession disconnectAndCloseAllConnectedSessions .
	MagmaServerConsole allInstances do: [:each | each shutdown].
	MagmaRepositoryController
		shutDown: 'ocmsdb'.! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'has 6/26/2013 06:56'!
updateDBObjects
	"I initialize MagmaCollection at the keys of OCMSDB if they do not exist"
	
	self commit:[
					(OCMSDB root includesKey: 'comments')
						ifFalse:[self session root at: 'comments' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'courses')
						ifFalse:[self session root at: 'courses' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'coursewares')
						ifFalse:[self session root at: 'coursewares' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'groups')
						ifFalse:[self session root at: 'groups' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'notifications')
						ifFalse:[self session root at: 'notifications' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'users')
						ifFalse:[self session root at: 'users' put: MagmaCollection new.].
					(OCMSDB root includesKey: 'tags')
						ifFalse:[self session root at: 'tags' put: MagmaCollection new.].
				]! !

!OCMSDB class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 00:45'!
updateIndexes
	"I initialize indexes of DBObjects in OCMSDB if they do not exist"
	| stringKeySize |
	stringKeySize := 128.
	
	self commit:[
		OCMSDB addIndexAt: 'comments' withIndex: (MaIntegerIndex attribute: #id).
		OCMSDB addIndexAt: 'comments' withIndex: ((MaSearchStringIndex attribute: #login) keySize: stringKeySize).
		OCMSDB addIndexAt: 'courses' withIndex: ((MaSearchStringIndex attribute: #description) keySize: stringKeySize).
		OCMSDB addIndexAt: 'coursewares' withIndex: (MaIntegerIndex attribute: #id).
		OCMSDB addIndexAt: 'coursewares' withIndex: ((MaSearchStringIndex attribute: #title) keySize: stringKeySize).
		OCMSDB addIndexAt: 'groups' withIndex: ((MaSearchStringIndex attribute: #description) keySize: stringKeySize).
		OCMSDB addIndexAt: 'notifications' withIndex: (MaIntegerIndex attribute: #id).
		OCMSDB addIndexAt: 'tags' withIndex: ((MaSearchStringIndex attribute: #label) keySize: stringKeySize).
		OCMSDB addIndexAt: 'users' withIndex: ((MaSearchStringIndex attribute: #login) keySize: stringKeySize).
		OCMSDB addIndexAt: 'users' withIndex: ((MaSearchStringIndex attribute: #username) keySize: stringKeySize).
		OCMSDB addIndexAt: 'users' withIndex: ((MaSearchStringIndex attribute: #email) keySize: stringKeySize).
	]! !

!OCMSDB methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:18'!
connect
	session := (MagmaRemoteLocation
				host: 'localhost'
				port: 51001) newSession.
	session connectAs: 'higor'.! !

!OCMSDB methodsFor: 'as yet unclassified' stamp: 'has 5/25/2013 19:19'!
session
	^ session! !

Object subclass: #OCMSTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

OCMSTable subclass: #Comments
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Comments class methodsFor: 'ma operation' stamp: 'has 6/29/2013 20:32'!
add: aComment
	"aComment createId."
	OCMSDB commit: [self database add: aComment].! !

!Comments class methodsFor: 'creation' stamp: 'has 6/22/2013 23:12'!
database
	^ OCMSDB root at: 'comments'.! !

!Comments class methodsFor: 'ma searching' stamp: 'has 6/23/2013 12:20'!
getAll
	"I return a collection with all comments in database"
	| reader |
	reader := self database where: [:each | each id > 0].
	^ reader.! !

!Comments class methodsFor: 'ma operation' stamp: 'has 6/23/2013 00:36'!
remove: aComment
	(self database includes: aComment)
		ifTrue:[OCMSDB commit: [self database remove: aComment]]
		ifFalse:[self error: 'This comment does not exist'].! !

!Comments class methodsFor: 'ma searching' stamp: 'has 6/23/2013 08:12'!
searchById: aHash
	"return a comment with the id or nil"
	
	| reader |
	reader := self database where: [:each | each id = aHash].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Comments class methodsFor: 'ma searching' stamp: 'has 6/24/2013 15:29'!
searchByUserLogin: anUserLogin
	"I return a collection with comments from the typed login"
	| reader |
	reader := self database where: [:each | each login from: anUserLogin to: anUserLogin maAlphabeticalNext].
	^ reader.! !

!Comments class methodsFor: 'ma operation' stamp: 'has 6/23/2013 00:43'!
update: aComment
	(self database includes: aComment)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aComment.
					self database add: aComment].
				]
		ifFalse:[self error: 'This comment does not exist'].! !

OCMSTable subclass: #Courses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Courses class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 01:42'!
add: aCourse
	OCMSDB commit: [
		self database add: aCourse
	].! !

!Courses class methodsFor: 'creation' stamp: 'has 6/23/2013 09:24'!
database
	^ OCMSDB root at: 'courses'.! !

!Courses class methodsFor: 'ma searching' stamp: 'oda 6/30/2013 16:45'!
getAll
	"I return a collection with all courses in database"
	| reader |
	reader := self database where: [:each | each read: #description from: '' maAlphabeticalNext].
	^ reader.! !

!Courses class methodsFor: 'ma searching' stamp: 'oda 7/1/2013 01:25'!
includes: aCourse
	^(self searchByDescription: aCourse description) notNil.! !

!Courses class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 01:40'!
remove: aCourse
	OCMSDB commit: [
		self database remove: aCourse
	]! !

!Courses class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 18:01'!
removeCascade: aCourse
	OCMSDB commit: [
		aCourse group do: [:aGroup | Groups remove: aGroup. ].
		self database remove: aCourse.
	]! !

!Courses class methodsFor: 'ma searching' stamp: 'oda 7/1/2013 00:47'!
searchByDescription: aDescription
	"I return a course that contains the typed description"
	| reader |
	reader := self database where: [:each | each read: #description at: aDescription].
	reader select: [:each | each description = aDescription].
	(reader isEmpty not)
		ifTrue: [^reader first.]  
		ifFalse: [^nil].  ! !

!Courses class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 01:42'!
update: aCourse
	OCMSDB commit: [
		self database update: aCourse.
	].
"
	(self database includes: aCourse)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aCourse.
					self database add: aCourse].
				]
		ifFalse:[self error: 'This course does not exist'].
"! !

OCMSTable subclass: #Coursewares
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Coursewares class methodsFor: 'ma operation' stamp: 'has 5/26/2013 11:59'!
add: aCourseware
	aCourseware id: self incrementId.
	OCMSDB commit: [self database add: aCourseware].! !

!Coursewares class methodsFor: 'creation' stamp: 'has 5/25/2013 20:15'!
database
	^ OCMSDB root at: 'coursewares'.! !

!Coursewares class methodsFor: 'ma searching' stamp: 'has 6/23/2013 12:27'!
getAll
	"I return a collection with all coursewares in database"
	| reader |
	reader := self database where: [:each | each id > 0].
	^ reader.! !

!Coursewares class methodsFor: 'creation' stamp: 'has 6/2/2013 16:45'!
incrementId
	| maxCourseware newId |
	newId := 0.
	(self database size > 0)
		ifTrue: [	maxCourseware := self database detectMax: #id.
				newId := maxCourseware id + 1]
		ifFalse: [newId := 1].
	^ newId.! !

!Coursewares class methodsFor: 'ma operation' stamp: 'has 6/2/2013 19:31'!
remove: aCourseware
	(self database includes: aCourseware)
		ifTrue:[OCMSDB commit: [self database remove: aCourseware]]
		ifFalse:[self error: 'This courseware does not exist'].! !

!Coursewares class methodsFor: 'ma operation' stamp: 'has 7/2/2013 08:40'!
removeCascade: aCourseware
	OCMSDB commit: [
		aCourseware comment do: [:aComment | Comments remove: aComment. ].
		self database remove: aCourseware.
	]! !

!Coursewares class methodsFor: 'ma searching' stamp: 'has 6/2/2013 10:19'!
searchById: anId
	"return a courseware with the id or nil"
	
	| reader |
	reader := self database where: [:each | each id = anId].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Coursewares class methodsFor: 'ma searching' stamp: 'oda 7/1/2013 15:32'!
searchByOwner: anUser
	"I return a collection with coursewares that is owned by anUser"
	| reader |
	reader := self getAll.
	^ reader select: [:each | each owner = anUser].! !

!Coursewares class methodsFor: 'ma searching' stamp: 'oda 7/2/2013 16:39'!
searchByTitle: aTitle
	"I return a collection with coursewares that contain the typed title"
	| reader |
	reader := self database where: [:each | each read: #title from: aTitle to: aTitle maAlphabeticalNext].
	^ reader select: [:each | each title = aTitle].! !

!Coursewares class methodsFor: 'ma operation' stamp: 'has 6/2/2013 18:18'!
update: aCourseware
	(self database includes: aCourseware)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aCourseware.
					self database add: aCourseware].
				]
		ifFalse:[self error: 'This courseware does not exist'].! !

OCMSTable subclass: #Groups
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Groups class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 01:42'!
add: aGroup
	OCMSDB commit: [
		self database add: aGroup
	].! !

!Groups class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 03:52'!
add: aGroup at: aCourse by: anUser
	OCMSDB commit: [
		aGroup owner: anUser.
		aGroup creationDateTime: DateAndTime now.

		aCourse includeGroup: aGroup.
		anUser includeOrUpdateGroup: aGroup withRole: (UserType moderator).
		
		self database add: aGroup.
		Users update: anUser.
		Groups update: aGroup.
	].! !

!Groups class methodsFor: 'creation' stamp: 'has 6/26/2013 06:49'!
database
	^ OCMSDB root at: 'groups'.! !

!Groups class methodsFor: 'ma searching' stamp: 'oda 6/30/2013 16:47'!
getAll
	"I return a collection with all groups in database"
	| reader |
	reader := self database where: [:each | each read: #description from: '' maAlphabeticalNext].
	^ reader.! !

!Groups class methodsFor: 'ma searching' stamp: 'oda 7/1/2013 01:24'!
includes: aGroup
	^(self searchByDescription: aGroup description andCourse: aGroup course) notNil.
! !

!Groups class methodsFor: 'ma searching' stamp: 'oda 7/2/2013 16:35'!
includes: aGroup at: aCourse
	^(self searchByDescription: aGroup description andCourse: aCourse) notNil.
! !

!Groups class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 18:01'!
remove: aGroup
	| aCourse |
	OCMSDB commit: [
		aCourse := aGroup course.
		self database remove: aGroup.
		aGroup user do: [:anUser |
			anUser removeGroup: aGroup.
			Users update: anUser.
		].
		aCourse removeGroup: aGroup.
		Courses update: aCourse.   
	].! !

!Groups class methodsFor: 'ma searching' stamp: 'oda 7/1/2013 00:19'!
searchByDescription: aDescription andCourse: aCourse
	"I return a  group that contains the typed description and group"
	| reader |
	reader := self database where: [:each | each read: #description at: aDescription].
	
	reader := reader select: [:each | each course = aCourse].
	(reader isEmpty not)
		ifTrue: [^reader first.]  
		ifFalse: [^nil].  ! !

!Groups class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 01:39'!
update: aGroup
	OCMSDB commit: [
		self database update: aGroup.
	].
"
	(self database includes: aGroup)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aGroup.
					self database add: aGroup].
				]
		ifFalse:[self error: 'This group does not exist'].
"! !

OCMSTable subclass: #OCMSNotifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!OCMSNotifications class methodsFor: 'ma operation' stamp: 'has 6/23/2013 15:18'!
add: aNotification
	OCMSDB commit: [self database add: aNotification].! !

!OCMSNotifications class methodsFor: 'creation' stamp: 'has 6/23/2013 07:08'!
database
	^ OCMSDB root at: 'notifications'.! !

!OCMSNotifications class methodsFor: 'ma searching' stamp: 'has 6/23/2013 12:21'!
getAll
	"I return a collection with all comments in database"
	| reader |
	reader := self database where: [:each | each id > 0].
	^ reader.! !

!OCMSNotifications class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:04'!
remove: aNotification
	(self database includes: aNotification)
		ifTrue:[OCMSDB commit: [self database remove: aNotification]]
		ifFalse:[self error: 'This notification does not exist'].! !

!OCMSNotifications class methodsFor: 'ma searching' stamp: 'has 6/23/2013 08:12'!
searchById: aHash
	"return a notification with the id or nil"
	
	| reader |
	reader := self database where: [:each | each id = aHash].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!OCMSNotifications class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:08'!
update: aNotification
	(self database includes: aNotification)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aNotification.
					self database add: aNotification].
				]
		ifFalse:[self error: 'This notification does not exist'].! !

!OCMSTable class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:35'!
add: anObject
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'creation' stamp: 'has 6/23/2013 08:32'!
database
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'ma searching' stamp: 'has 6/23/2013 08:43'!
getAll
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:39'!
remove: anObject
	self subclassResponsibility! !

!OCMSTable class methodsFor: 'ma operation' stamp: 'has 6/23/2013 08:40'!
update: anObject
	self subclassResponsibility! !

OCMSTable subclass: #Tags
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Tags class methodsFor: 'ma operation' stamp: 'has 6/24/2013 19:22'!
add: aTag
	(self tagExists: aTag)
		ifFalse:[OCMSDB commit:[self database add: aTag]]
		ifTrue:[self error: 'This tag already exists.'].! !

!Tags class methodsFor: 'creation' stamp: 'has 6/3/2013 09:44'!
database
	^ OCMSDB root at: 'tags'.! !

!Tags class methodsFor: 'ma searching' stamp: 'oda 6/30/2013 16:46'!
getAll
	"I return a collection with all tags in database"
	| reader |
	reader := self database where: [:each | each read: #label from: '' maAlphabeticalNext].
	^ reader.! !

!Tags class methodsFor: 'testing' stamp: 'has 6/28/2013 15:05'!
labelExists: aTagLabel
	"I return true if the tag already exists."
	| tagTemp |
	(self database size = 0)
		ifTrue:[^false].
		
	tagTemp := self searchTagByLabel: aTagLabel.
	(tagTemp isNil)
		ifTrue:[^ false]
		ifFalse:[^ true].! !

!Tags class methodsFor: 'ma operation' stamp: 'has 6/3/2013 10:22'!
remove: aTag
	(self tagExists: aTag)
		ifTrue:[OCMSDB commit: [self database remove: aTag]]
		ifFalse:[self error: 'This tag does not exist'].! !

!Tags class methodsFor: 'ma searching' stamp: 'has 6/28/2013 14:35'!
searchTag: aTag
	"I return a collection with tags that contain the typed tag name"
	| reader tagLabel |
	tagLabel := aTag label.
	reader := self database where: [:each | each label from: tagLabel to: tagLabel maAlphabeticalNext].
	^ reader.! !

!Tags class methodsFor: 'ma searching' stamp: 'has 6/28/2013 14:36'!
searchTagByLabel: aTagLabel
	"I return a collection with tags that contain the typed tag name"
	| reader |
	reader := self database where: [:each | each label from: aTagLabel to: aTagLabel maAlphabeticalNext].
	^ reader.! !

!Tags class methodsFor: 'testing' stamp: 'has 6/28/2013 14:45'!
tagExists: aTag
	"I return true if the tag already exists."
	| tagTemp |
	(self database size = 0)
		ifTrue:[^false].
		
	tagTemp := self searchTag: aTag.
	(tagTemp isNil)
		ifTrue:[^ false]
		ifFalse:[^ true].! !

!Tags class methodsFor: 'ma operation' stamp: 'has 6/3/2013 10:22'!
update: aTag
	(self tagExists: aTag)
		ifTrue:[
				OCMSDB commit: [
					self database remove: aTag.
					self database add: aTag].
				]
		ifFalse:[self error: 'This tag does not exist'].! !

OCMSTable subclass: #Users
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCMS-Database'!

!Users class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 17:35'!
add: anUser
	(self loginExists: anUser login)
		ifFalse:[OCMSDB commit:[self database add: anUser]]
		ifTrue:[self error: 'This login already exists.'].! !

!Users class methodsFor: 'creation' stamp: 'has 6/2/2013 19:00'!
database
	^ OCMSDB root at: 'users'.! !

!Users class methodsFor: 'ma searching' stamp: 'oda 6/30/2013 16:47'!
getAll
	"I return a collection with all users in database"
	| reader |
	reader := self database where: [:each | each read: #login from: '' maAlphabeticalNext].
	^ reader.! !

!Users class methodsFor: 'testing' stamp: 'oda 7/1/2013 17:36'!
loginExists: aLogin
	"I return true if the login already exists."
	| userTemp |
	userTemp := self searchByLogin: aLogin.
	^userTemp notNil.! !

!Users class methodsFor: 'ma operation' stamp: 'has 6/2/2013 19:32'!
remove: anUser
	(self database includes: anUser)
		ifTrue:[OCMSDB commit: [self database remove: anUser]]
		ifFalse:[self error: 'This user does not exist'].! !

!Users class methodsFor: 'ma searching' stamp: 'has 6/24/2013 21:12'!
searchByEmail: anEmail
	"return an user with the email typed or nil"
	| reader |
	reader := self database where: [:each | each email from: anEmail to: anEmail maAlphabeticalNext].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Users class methodsFor: 'ma searching' stamp: 'oda 7/1/2013 17:26'!
searchByLogin: aLogin
	"return an user with the login typed or nil"
	| reader |
	reader := self database where: [:each | each read: #login from: aLogin to: aLogin maAlphabeticalNext].
	reader select: [:each | each login = aLogin].
	(reader isEmpty not)
		ifTrue:[^ reader first].
		^ nil.! !

!Users class methodsFor: 'ma searching' stamp: 'has 6/27/2013 19:09'!
searchByName: aName
	"I return a collection with users that contain the typed name"
	| reader |
	reader := self database where: [:each | each username from: aName to: aName maAlphabeticalNext].
	^ reader.! !

!Users class methodsFor: 'ma operation' stamp: 'oda 7/1/2013 18:02'!
update: anUser
	OCMSDB commit: [
		self database update: anUser.
	]
	
"
	(self database includes: anUser)
		ifTrue:[
				OCMSDB commit: [
					self database remove: anUser.
					self database add: anUser].
				]
		ifFalse:[self error: 'This user does not exist'].
"! !
